"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _InputAdapter = _interopRequireDefault(require("./adapters/InputAdapter"));

var _SelectAdapter = _interopRequireDefault(require("./adapters/SelectAdapter"));

var _TextareaAdapter = _interopRequireDefault(require("./adapters/TextareaAdapter"));

var _MultiSelectAdapter = _interopRequireDefault(require("./adapters/MultiSelectAdapter"));

var _ImagePickerAdapter = _interopRequireDefault(require("./adapters/ImagePickerAdapter"));

var _MultiSelectTreeAdapter = _interopRequireDefault(require("./adapters/MultiSelectTreeAdapter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

class CommonAdapters {
  static all() {
    return [{
      name: 'string',
      // eslint-disable-next-line react/display-name
      render: (field, props) => {
        return /*#__PURE__*/_react.default.createElement(_InputAdapter.default, _extends({}, props, {
          field: field
        }));
      }
    }, {
      name: 'textarea',
      // eslint-disable-next-line react/display-name
      render: (field, props) => {
        return /*#__PURE__*/_react.default.createElement(_TextareaAdapter.default, _extends({}, props, {
          field: field
        }));
      }
    }, {
      name: 'select',
      // eslint-disable-next-line react/display-name
      render: (field, props) => {
        return /*#__PURE__*/_react.default.createElement(_SelectAdapter.default, _extends({}, props, {
          field: field
        }));
      }
    }, {
      name: 'multi-select',
      // eslint-disable-next-line react/display-name
      render: (field, props) => {
        return /*#__PURE__*/_react.default.createElement(_MultiSelectAdapter.default, _extends({}, props, {
          field: field
        }));
      }
    }, {
      name: 'multi-select-tree',
      // eslint-disable-next-line react/display-name
      render: (field, props) => {
        return /*#__PURE__*/_react.default.createElement(_MultiSelectTreeAdapter.default, _extends({}, props, {
          field: field
        }));
      }
    }, {
      name: 'image-picker',
      // eslint-disable-next-line react/display-name
      render: (field, props) => {
        return /*#__PURE__*/_react.default.createElement(_ImagePickerAdapter.default, _extends({}, props, {
          field: field
        }));
      }
    }];
  }

  static allValidators() {
    return [{
      name: 'equals',
      message: 'Should be equals',
      validator: async (rule, value, form) => {
        if (form.getFieldValue(rule.to) !== value) {
          throw Error('Not equal');
        }
      }
    }];
  }

}

exports.default = CommonAdapters;
//# sourceMappingURL=CommonAdapters.js.map