"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MultiSelectDropDown = void 0;

var _react = _interopRequireWildcard(require("react"));

var _MutlitSelectStyles = require("./MutlitSelectStyles");

var _nativeBase = require("native-base");

var _reactNative = require("react-native");

var _AntDesign = _interopRequireDefault(require("react-native-vector-icons/AntDesign"));

var _SelectSearchBar = require("./SelectSearchBar");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const MultiSelectDropDown = props => {
  const {
    label,
    labelProps,
    pickerList,
    onChange,
    validationInfo,
    placeholder,
    value,
    type,
    tagColor
  } = props;
  const [showPickerList, setShowPickerList] = (0, _react.useState)(false);
  const [pickedList, setPickedList] = (0, _react.useState)([]);
  const [dataList, setDataList] = (0, _react.useState)([]);
  (0, _react.useEffect)(() => {
    setDataList(pickerList);
  }, [pickerList]);

  const onSelect = (value, selected) => {
    const index = dataList.findIndex(value1 => value1.value === value.value);
    const temp = dataList.slice();
    temp[index] = _objectSpread(_objectSpread({}, value), {}, {
      isSelected: selected
    });
    setDataList(temp);
  };

  const removeItem = val => {
    const temp = pickedList.filter(item => item.value !== val.value);
    onSelect(val, false);
    setPickedList(temp);
    onChange(temp.map(item => item.value));
  };

  const renderTags = () => {
    if (pickedList.length === 0) {
      return /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
        style: {
          marginTop: 5,
          marginBottom: 5,
          color: '#C4C4C4'
        }
      }, placeholder !== null && placeholder !== void 0 ? placeholder : 'Click to select');
    }

    return pickedList.map((item, index) => {
      return /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
        style: [_MutlitSelectStyles.styles.tagContainer, {
          backgroundColor: tagColor !== null && tagColor !== void 0 ? tagColor : '#FD8282'
        }],
        key: index
      }, /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
        style: {
          marginRight: 5,
          color: 'white'
        },
        numberOfLines: 1,
        onPress: () => setShowPickerList(!showPickerList)
      }, item.label), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
        style: {
          paddingLeft: 20,
          paddingRight: 20
        },
        onPress: () => removeItem(item)
      }, /*#__PURE__*/_react.default.createElement(_AntDesign.default, {
        style: {
          color: 'white',
          fontSize: 15
        },
        name: 'closecircleo'
      })));
    });
  };

  const onComplete = val => {
    setPickedList(val);
    onChange(val.map(item => item.value));
  };

  (0, _react.useEffect)(() => {
    if (value && value.length > 0) {
      const temp = pickerList.filter(item => value.includes(item.value));
      setPickedList(temp);
      const tem = pickerList.slice();

      for (const val of value) {
        const ind = tem.findIndex(itm => itm.value === val);
        tem[ind] = _objectSpread(_objectSpread({}, tem[ind]), {}, {
          isSelected: true
        });
      }

      setDataList(tem);
    }
  }, [pickerList, value]);

  const renderElement = (selectStyleX, labelStyle) => {
    return /*#__PURE__*/_react.default.createElement(_nativeBase.Item, {
      stackedLabel: label !== undefined,
      style: _MutlitSelectStyles.styles.itemStyle
    }, label && /*#__PURE__*/_react.default.createElement(_nativeBase.Label, _extends({}, labelProps, {
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, labelStyle), labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) : labelStyle
    }), label, '   ', validationInfo && (validationInfo === null || validationInfo === void 0 ? void 0 : validationInfo.length) > 0 && /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: {
        color: '#f39c12',
        marginLeft: 5
      }
    }, validationInfo)), pickedList.length === 0 ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: _MutlitSelectStyles.styles.default,
      onPress: () => setShowPickerList(!showPickerList)
    }, /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
      style: [selectStyleX, {
        padding: 8
      }]
    }, renderTags())) : /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity // style={{ width: '100%', backgroundColor: 'blue'}}
    , {
      onPress: () => setShowPickerList(!showPickerList)
    }, /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
      style: [_MutlitSelectStyles.styles.default, selectStyleX, {
        flexDirection: 'row',
        padding: 6
      }],
      onStartShouldSetResponder: () => true
    }, /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, {
      horizontal: true
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: {
        alignSelf: 'stretch',
        flexDirection: 'row'
      },
      onPress: () => setShowPickerList(!showPickerList)
    }, renderTags()), /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: [{
        alignSelf: 'stretch',
        color: 'transparent'
      }],
      onPress: () => setShowPickerList(!showPickerList)
    }, ' ', "************* **********")))), /*#__PURE__*/_react.default.createElement(_SelectSearchBar.SelectSearchBar, {
      onSelect: onSelect,
      onComplete: onComplete,
      data: dataList,
      showModal: showPickerList,
      closeModal: () => setShowPickerList(false),
      value: pickedList
    }));
  };

  switch (type) {
    case 'bordered':
      return renderElement(_objectSpread({}, _MutlitSelectStyles.styles.bordered), _objectSpread(_objectSpread({}, _MutlitSelectStyles.styles.textDefault), {}, {
        color: '#979797'
      }));

    default:
      return renderElement(_MutlitSelectStyles.styles.multiSelect, _MutlitSelectStyles.styles.textDefault);
  }
};

exports.MultiSelectDropDown = MultiSelectDropDown;
//# sourceMappingURL=MultiSelectDropDown.js.map