"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectSearchBar = void 0;

var _react = _interopRequireWildcard(require("react"));

var _nativeBase = require("native-base");

var _reactNative = require("react-native");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const {
  width
} = _reactNative.Dimensions.get('window');

const styles = _reactNative.StyleSheet.create({
  barContainer: {
    padding: 5,
    justifyContent: 'center',
    flexDirection: 'row' // top: 40,

  },
  searchInput: {
    borderWidth: 3,
    backgroundColor: '#f2f2f7',
    borderRadius: 20,
    margin: 6,
    padding: 10,
    justifyContent: 'center',
    flexDirection: 'row',
    height: 45,
    width: width * 0.8
  },
  icon: {},
  doneButton: {
    alignItems: 'center',
    justifyContent: 'center',
    margin: 10,
    flexDirection: 'row',
    borderBottomWidth: 0
  },
  cancel: {
    color: '#5FC9F8'
  }
});

const SelectSearchBar = props => {
  const {
    placeholder,
    data,
    value,
    showModal,
    onSelect,
    closeModal,
    onComplete
  } = props;
  const [isEditing, setIsEditing] = (0, _react.useState)(false);
  const [display, setDisplay] = (0, _react.useState)(false);
  const [pickedList, setPickedList] = (0, _react.useState)([]);
  const [searchText, setSearchText] = (0, _react.useState)(''); // const [selected, setSelected] = React.useState(new Map());

  const onchangeText = text => {
    setIsEditing(text !== '');
    setSearchText(text);
  };

  const handlerChanged = val => {
    const temp = pickedList;
    const index = temp.findIndex(item => item.value === val.value);

    if (index === -1) {
      // val.isSelected = true;
      onSelect(val, true);
      temp.push(val);
    } else {
      temp.splice(index, 1);
      onSelect(val, false);
    }

    setPickedList(temp);
    setDisplay(false);
  }; // const handleKeyDown = (e: { nativeEvent: { key: string } }) => {
  //   alert('yo');
  //   if (e.nativeEvent.key == 'Enter') {
  //     alert('go');
  //     Keyboard.dismiss();
  //   }
  // };


  const doneSelect = () => {
    onComplete(pickedList); // selected.clear();

    closeModal();
  };

  (0, _react.useEffect)(() => {
    if (value) {
      setPickedList(value);
    }
  }, [value]);
  return /*#__PURE__*/_react.default.createElement(_reactNative.Modal, {
    visible: showModal,
    onDismiss: closeModal
  }, /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
    style: styles.barContainer
  }, /*#__PURE__*/_react.default.createElement(_nativeBase.View, null, /*#__PURE__*/_react.default.createElement(_nativeBase.Item, {
    style: styles.searchInput,
    onPress: () => setDisplay(!display)
  }, /*#__PURE__*/_react.default.createElement(_nativeBase.Input, {
    placeholder: placeholder ? placeholder : 'Search',
    onChangeText: onchangeText,
    autoFocus: true,
    returnKeyType: 'done',
    value: searchText // onKeyPress={handleKeyDown}
    // onSubmitEditing={(e) => handlerChanged(e.nativeEvent.text)}

  }), /*#__PURE__*/_react.default.createElement(_nativeBase.Icon, {
    style: styles.icon,
    onPress: () => {
      setSearchText('');
      setIsEditing(false);
      setDisplay(false); // setData([]);
    },
    name: isEditing || value !== undefined ? 'close' : 'ios-search'
  }))), /*#__PURE__*/_react.default.createElement(_nativeBase.Item, {
    style: styles.doneButton
  }, /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
    style: styles.cancel,
    onPress: doneSelect
  }, "Done"))), data.length === 0 ? /*#__PURE__*/_react.default.createElement(_nativeBase.Spinner, {
    color: "green"
  }) : /*#__PURE__*/_react.default.createElement(_reactNative.FlatList // style={{marginTop: 60}}
  , {
    maxToRenderPerBatch: 10,
    data: searchText === '' ? data : data.filter(item => item.label.toLowerCase().includes(searchText.toLowerCase())),
    disableScrollViewPanResponder: true,
    renderItem: ({
      item,
      index
    }) => /*#__PURE__*/_react.default.createElement(_nativeBase.ListItem, {
      key: index,
      style: {
        marginRight: 15,
        marginLeft: 15
      },
      onPress: () => handlerChanged(item)
    }, /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: {
        color: (item === null || item === void 0 ? void 0 : item.isSelected) === true ? '#FD8282' : 'black'
      }
    }, item.label)),
    keyExtractor: item => item.value,
    extraData: data,
    scrollEnabled: true,
    style: {
      marginBottom: 80
    }
  })));
};

exports.SelectSearchBar = SelectSearchBar;
//# sourceMappingURL=SelectSearchBar.js.map