"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TreeDropdown = void 0;

var _react = _interopRequireWildcard(require("react"));

var _nativeBase = require("native-base");

var _reactNative = require("react-native");

var _AntDesign = _interopRequireDefault(require("react-native-vector-icons/AntDesign"));

var _style = require("./style");

var _DropdownList = require("./DropdownList");

var _TreeDropdownContext = _interopRequireDefault(require("./TreeDropdownContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const TreeDropdown = props => {
  const {
    label,
    labelProps,
    pickerList,
    onChange,
    validationInfo,
    value,
    type,
    childName,
    parentName,
    placeholder
  } = props;
  const [showPickerList, setShowPickerList] = (0, _react.useState)(false);
  const context = (0, _react.useContext)(_TreeDropdownContext.default).current;
  const {
    removeTag,
    setSelectedList,
    selectedList
  } = context;
  (0, _react.useEffect)(() => {
    if (value) {
      setSelectedList(value);
    }
  }, [value]);

  const renderTags = () => {
    if (selectedList.length === 0) {
      return /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
        style: {
          marginTop: 5,
          marginBottom: 5,
          color: '#C4C4C4'
        }
      }, placeholder !== null && placeholder !== void 0 ? placeholder : 'Click to select');
    }

    return selectedList.map((item, ind) => {
      const originalVal = pickerList.find(clr => clr.parent.value === item[parentName]);
      return item[childName].map((val, index) => {
        var _originalVal$color, _originalVal$children;

        return /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
          style: [_style.styles.tagContainer, {
            backgroundColor: (_originalVal$color = originalVal === null || originalVal === void 0 ? void 0 : originalVal.color) !== null && _originalVal$color !== void 0 ? _originalVal$color : '#FD8282'
          }],
          key: "".concat(ind).concat(index)
        }, /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
          numberOfLines: 1,
          onPress: () => setShowPickerList(!showPickerList),
          style: {
            color: 'white'
          }
        }, originalVal === null || originalVal === void 0 ? void 0 : originalVal.parent.label, " ", " ", ' ', originalVal === null || originalVal === void 0 ? void 0 : (_originalVal$children = originalVal.children.find(x => x.value === val)) === null || _originalVal$children === void 0 ? void 0 : _originalVal$children.label), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
          style: {
            paddingLeft: 20,
            paddingRight: 20
          },
          onPress: () => removeTag({
            action: 'remove',
            childId: val,
            parentId: item[parentName]
          })
        }, /*#__PURE__*/_react.default.createElement(_AntDesign.default, {
          style: {
            color: 'white',
            fontSize: 15
          },
          name: 'closecircleo'
        })));
      });
    });
  };

  const onComplete = val => {
    onChange(val.length === 0 ? undefined : val);
    setSelectedList(val);
  };

  const renderElement = (selectStyleX, labelStyle) => {
    return /*#__PURE__*/_react.default.createElement(_nativeBase.Item, {
      stackedLabel: label !== undefined,
      style: _style.styles.itemStyle
    }, label && /*#__PURE__*/_react.default.createElement(_nativeBase.Label, _extends({}, labelProps, {
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, labelStyle), labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) : labelStyle
    }), label, '   ', validationInfo && (validationInfo === null || validationInfo === void 0 ? void 0 : validationInfo.length) > 0 && /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: {
        color: '#f39c12',
        marginLeft: 5
      }
    }, validationInfo)), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: _style.styles.default,
      onPress: () => setShowPickerList(!showPickerList)
    }, selectedList.length === 0 ? /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
      style: selectStyleX
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: [{
        flexDirection: 'row'
      }]
    }, renderTags())) : /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
      onStartShouldSetResponder: () => true,
      style: selectStyleX
    }, /*#__PURE__*/_react.default.createElement(_reactNative.ScrollView, {
      horizontal: true,
      style: {
        flexDirection: 'row',
        flex: 1
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      style: [{
        flexDirection: 'row'
      }],
      onPress: () => setShowPickerList(!showPickerList)
    }, renderTags()), /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: [{
        alignSelf: 'stretch',
        color: 'transparent'
      }],
      onPress: () => setShowPickerList(!showPickerList)
    }, ' ', "************* **********"))), /*#__PURE__*/_react.default.createElement(_DropdownList.DropdownList, {
      onChange: onComplete,
      parentName: parentName,
      childName: childName,
      data: pickerList,
      showModal: showPickerList,
      closeModal: () => setShowPickerList(false),
      value: value
    })));
  };

  switch (type) {
    case 'bordered':
      return renderElement(_objectSpread({}, _style.styles.bordered), _objectSpread(_objectSpread({}, _style.styles.textDefault), {}, {
        color: '#979797'
      }));

    default:
      return renderElement(_style.styles.multiSelect, _style.styles.textDefault);
  }
};

exports.TreeDropdown = TreeDropdown;
//# sourceMappingURL=TreeDropdown.js.map