"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TreeDropdownContextProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const TreeDropdownContext = _react.default.createContext({});

const TreeDropdownContextProvider = props => {
  const {
    children,
    childName,
    parentName
  } = props;
  const [selectedList, setSelectedList] = (0, _react.useState)([]);

  const selectChild = (childId, parentId) => {
    const temp = selectedList.slice();

    if (temp.length === 0) {
      temp.push({
        [parentName]: parentId,
        [childName]: [childId]
      });
    } else {
      const i = temp.findIndex(val => val[parentName] === parentId);

      if (i > -1) {
        const v = temp[i];
        const childI = v[childName].findIndex(val => val === childId);

        if (childI > -1) {
          if (v[childName].length === 1) {
            temp.splice(i, 1);
          } else {
            v[childName].splice(childI, 1);
            temp[i] = v;
          }
        } else {
          v[childName].push(childId);
          temp[i] = v;
        }
      } else {
        temp.push({
          [parentName]: parentId,
          [childName]: [childId]
        });
      }
    }

    setSelectedList(temp); // console.log('furious ', temp);
  };

  const removeTag = item => {
    const temp = selectedList.slice();
    const x = temp.findIndex(val => val[parentName] === item.parentId);

    if (x === -1) {
      return;
    }

    const ind = temp[x][childName].findIndex(itm => itm === item.childId);

    if (ind > -1) {
      if (temp[x][childName].length === 1) {
        temp.splice(x, 1);
      } else {
        temp[x][childName].splice(ind, 1);
      }
    }

    setSelectedList(temp);
  };

  return /*#__PURE__*/_react.default.createElement(TreeDropdownContext.Provider, {
    value: {
      current: {
        setSelectedList,
        selectedList,
        selectChild,
        removeTag
      }
    }
  }, children);
};

exports.TreeDropdownContextProvider = TreeDropdownContextProvider;
var _default = TreeDropdownContext;
exports.default = _default;
//# sourceMappingURL=TreeDropdownContext.js.map