"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TreeListItem = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _nativeBase = require("native-base");

var _AntDesign = _interopRequireDefault(require("react-native-vector-icons/AntDesign"));

var _style = require("./style");

var _TreeDropdownContext = _interopRequireDefault(require("./TreeDropdownContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// type selectedChildProp = {
//   [key: string]: string[];
// };
// export type selectedListProps = {
//   key: selectedParentProp;
//   [keyChild: string]: string[];
// };
const TreeListItem = props => {
  const {
    data,
    childName,
    parentName,
    value,
    onChange
  } = props;
  const context = (0, _react.useContext)(_TreeDropdownContext.default).current;
  const {
    selectedList,
    setSelectedList,
    selectChild
  } = context;
  (0, _react.useEffect)(() => {
    if (value) {
      setSelectedList(value);
    }
  }, [value]);
  (0, _react.useEffect)(() => {
    onChange(selectedList);
  }, [selectedList]);

  const checkSelected = (parentId, childId) => {
    if (selectedList.length === 0) {
      return false;
    }

    const x = selectedList.find(val => val[parentName] === parentId);

    if (!x) {
      return false;
    }

    const ind = x[childName].findIndex(itm => itm === childId);
    return ind !== -1;
  };

  const _renderHeader = (item, expanded) => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: {
        flexDirection: 'row',
        padding: 10,
        justifyContent: 'space-between',
        alignItems: 'center',
        backgroundColor: 'white'
      }
    }, /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: {
        fontWeight: '600',
        color: '#666666'
      }
    }, ' ', item.parent.label), expanded ? /*#__PURE__*/_react.default.createElement(_AntDesign.default, {
      style: {
        fontSize: 18
      },
      name: "up"
    }) : /*#__PURE__*/_react.default.createElement(_AntDesign.default, {
      style: {
        fontSize: 18
      },
      name: "down"
    }));
  };

  const _renderContent = val => {
    return /*#__PURE__*/_react.default.createElement(_reactNative.FlatList, {
      maxToRenderPerBatch: 10,
      data: val.children,
      renderItem: ({
        item,
        index
      }) => /*#__PURE__*/_react.default.createElement(_nativeBase.ListItem, {
        key: index
      }, /*#__PURE__*/_react.default.createElement(_nativeBase.Body, null, /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
        style: _style.styles.childText
      }, item.label)), /*#__PURE__*/_react.default.createElement(_nativeBase.CheckBox, {
        color: '#979797',
        style: _style.styles.checkbox,
        onPress: () => selectChild(item.value, val.parent.value),
        checked: checkSelected(val.parent.value, item.value)
      })),
      keyExtractor: item => item.value,
      scrollEnabled: true
    });
  };

  return /*#__PURE__*/_react.default.createElement(_reactNative.View, null, /*#__PURE__*/_react.default.createElement(_nativeBase.Accordion, {
    dataArray: data // animation={true}
    // expanded={true}
    ,
    renderHeader: _renderHeader,
    renderContent: _renderContent
  }));
};

exports.TreeListItem = TreeListItem;
//# sourceMappingURL=TreeListItem.js.map