"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImagePicker = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styles = require("./styles");

var _nativeBase = require("native-base");

var _reactNative = require("react-native");

var _reactNativeImagePicker = _interopRequireDefault(require("react-native-image-picker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const ImagePicker = props => {
  const {
    type,
    label,
    labelProps,
    style,
    ImagePickerStyle,
    validationInfo,
    onChange,
    value,
    pickerOptions
  } = props;
  const [image, setImage] = (0, _react.useState)();
  const options = {
    title: 'Select Picture',
    mediaType: 'photo',
    allowsEditing: true,
    quality: 0.7,
    // storageOptions: {
    //   skipBackup: true,
    //   path: 'images',
    // },
    maxWidth: type === 'avatar' ? 300 : 1000,
    maxHeight: type === 'avatar' ? 300 : 700
  }; // useEffect(() => {
  //  if(type === 'avatar'){
  //    setImageProps({
  //
  //    })
  //  }
  // })

  const onPress = () => {
    _reactNativeImagePicker.default.showImagePicker(pickerOptions ? _objectSpread(_objectSpread({}, options), pickerOptions) : options, response => {
      if (response.didCancel) {
        console.log('User cancelled image picker');
      } else if (response.error) {
        console.log('ImagePicker Error: ', response.error);
      } else if (response.customButton) {
        console.log('User tapped custom button: ', response.customButton);
      } else {
        setImage({
          uri: response.uri
        });
        onChange("data:image/png;base64,".concat(response.data));
      }
    });
  };

  const imageSrc = (0, _react.useMemo)(() => {
    if (value && (value === (image === null || image === void 0 ? void 0 : image.uri) || (image === null || image === void 0 ? void 0 : image.uri) === undefined)) {
      return {
        uri: value
      };
    }

    return image;
  }, [value, image]);

  const renderElement = pickerStyleX => {
    return /*#__PURE__*/_react.default.createElement(_nativeBase.Item, {
      stackedLabel: label !== undefined,
      style: style !== undefined ? _objectSpread(_objectSpread({}, _styles.styles.itemStyle), style) : _styles.styles.itemStyle
    }, label && /*#__PURE__*/_react.default.createElement(_nativeBase.Label, _extends({}, labelProps, {
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, _styles.styles.textDefault), labelProps.style) : _styles.styles.textDefault
    }), label, '   ', validationInfo && (validationInfo === null || validationInfo === void 0 ? void 0 : validationInfo.length) > 0 && /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: {
        color: '#f39c12',
        marginLeft: 5
      }
    }, validationInfo)), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: onPress
    }, !imageSrc ? /*#__PURE__*/_react.default.createElement(_nativeBase.View, {
      style: ImagePickerStyle ? _objectSpread(_objectSpread({}, ImagePickerStyle), pickerStyleX) : pickerStyleX
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      style: {
        height: 50,
        width: 50
      },
      source: require('./ImageIcon.png')
    })) : /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      source: imageSrc // resizeMethod={'resize'}
      ,
      resizeMode: type === 'avatar' ? undefined : 'cover',
      style: ImagePickerStyle ? _objectSpread(_objectSpread({}, ImagePickerStyle), pickerStyleX) : pickerStyleX
    })));
  };

  if (type === 'avatar') {
    return renderElement(_styles.styles.avatar);
  }

  return renderElement(_styles.styles.defaultImage);
};

exports.ImagePicker = ImagePicker;
//# sourceMappingURL=ImagePicker.js.map