"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _nativeBase = require("native-base");

var _reactNative = require("react-native");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const Select = props => {
  const {
    selectStyle,
    validationInfo,
    label,
    style,
    labelProps,
    type,
    pickerList,
    pickerProps
  } = props;
  const propsX = props;
  delete propsX.style;

  const renderElement = (selectStyleX, labelStyle) => {
    return /*#__PURE__*/_react.default.createElement(_nativeBase.Item, {
      stackedLabel: label !== undefined,
      style: style !== undefined ? _objectSpread(_objectSpread({}, _styles.styles.itemStyle), style) : _styles.styles.itemStyle
    }, label && /*#__PURE__*/_react.default.createElement(_nativeBase.Label, _extends({}, labelProps, {
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, labelStyle), labelProps.style) : labelStyle
    }), label, '   ', validationInfo && (validationInfo === null || validationInfo === void 0 ? void 0 : validationInfo.length) > 0 && /*#__PURE__*/_react.default.createElement(_nativeBase.Text, {
      style: {
        color: '#f39c12',
        marginLeft: 5
      }
    }, validationInfo)), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: selectStyleX
    }, /*#__PURE__*/_react.default.createElement(_nativeBase.Picker, _extends({
      iosIcon: /*#__PURE__*/_react.default.createElement(_nativeBase.Icon, {
        style: {
          alignSelf: 'center',
          color: '#C4C4C4'
        },
        name: "arrow-down"
      }),
      placeholderStyle: {
        color: '#C4C4C4',
        fontSize: 16,
        lineHeight: 18
      },
      itemTextStyle: {
        color: '#4a4a4a'
      },
      itemStyle: {
        fontSize: 14
      },
      textStyle: {
        color: '#4a4a4a'
      },
      mode: "dropdown"
    }, propsX, {
      style: [selectStyle]
    }), pickerList.filter(val => !(_reactNative.Platform.OS === 'ios' && val.value === '')).map((item, index) => {
      var _item$color;

      return /*#__PURE__*/_react.default.createElement(_nativeBase.Picker.Item, _extends({
        key: index,
        label: item.label,
        value: item.value,
        color: (_item$color = item.color) !== null && _item$color !== void 0 ? _item$color : '#4a4a4a'
      }, pickerProps));
    }))));
  };

  switch (type) {
    case 'material':
      return renderElement(_styles.styles.material, _styles.styles.textMaterial);

    case 'bordered':
      return renderElement(_styles.styles.bordered, _objectSpread(_objectSpread({}, _styles.styles.textDefault), {}, {
        color: '#979797'
      }));

    case 'material-black':
      return renderElement([_styles.styles.material, {
        color: 'black',
        borderColor: 'black'
      }], _objectSpread(_objectSpread({}, _styles.styles.textDefault), {}, {
        color: 'black'
      }));

    default:
      return renderElement(_styles.styles.default, _styles.styles.textDefault);
  }
};

exports.Select = Select;
//# sourceMappingURL=Select.js.map