import React, { useEffect, useState } from 'react';
import { Icon, Input, Item, ListItem, Text, View, Spinner } from 'native-base';
import { Dimensions, StyleSheet, Modal, FlatList, SafeAreaView } from 'react-native';
const {
  width
} = Dimensions.get('window');
const styles = StyleSheet.create({
  barContainer: {
    padding: 5,
    justifyContent: 'center',
    flexDirection: 'row' // top: 40,

  },
  searchInput: {
    borderWidth: 3,
    backgroundColor: '#f2f2f7',
    borderRadius: 20,
    margin: 6,
    padding: 10,
    justifyContent: 'center',
    flexDirection: 'row',
    height: 45,
    width: width * 0.8
  },
  icon: {},
  doneButton: {
    alignItems: 'center',
    justifyContent: 'center',
    margin: 10,
    flexDirection: 'row',
    borderBottomWidth: 0
  },
  cancel: {
    color: '#5FC9F8'
  }
});
export const SelectSearchBar = props => {
  const {
    placeholder,
    data,
    value,
    showModal,
    onSelect,
    closeModal,
    onComplete
  } = props;
  const [isEditing, setIsEditing] = useState(false);
  const [display, setDisplay] = useState(false);
  const [pickedList, setPickedList] = useState([]);
  const [searchText, setSearchText] = useState(''); // const [selected, setSelected] = React.useState(new Map());

  const onchangeText = text => {
    setIsEditing(text !== '');
    setSearchText(text);
  };

  const handlerChanged = val => {
    const temp = pickedList;
    const index = temp.findIndex(item => item.value === val.value);

    if (index === -1) {
      // val.isSelected = true;
      onSelect(val, true);
      temp.push(val);
    } else {
      temp.splice(index, 1);
      onSelect(val, false);
    }

    setPickedList(temp);
    setDisplay(false);
  }; // const handleKeyDown = (e: { nativeEvent: { key: string } }) => {
  //   alert('yo');
  //   if (e.nativeEvent.key == 'Enter') {
  //     alert('go');
  //     Keyboard.dismiss();
  //   }
  // };


  const doneSelect = () => {
    onComplete(pickedList); // selected.clear();

    closeModal();
  };

  useEffect(() => {
    if (value) {
      setPickedList(value);
    }
  }, [value]);
  return /*#__PURE__*/React.createElement(Modal, {
    visible: showModal,
    onDismiss: closeModal
  }, /*#__PURE__*/React.createElement(SafeAreaView, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(View, {
    style: styles.barContainer
  }, /*#__PURE__*/React.createElement(View, null, /*#__PURE__*/React.createElement(Item, {
    style: styles.searchInput,
    onPress: () => setDisplay(!display)
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: placeholder ? placeholder : 'Search',
    onChangeText: onchangeText,
    autoFocus: true,
    returnKeyType: 'done',
    value: searchText // onKeyPress={handleKeyDown}
    // onSubmitEditing={(e) => handlerChanged(e.nativeEvent.text)}

  }), /*#__PURE__*/React.createElement(Icon, {
    style: styles.icon,
    onPress: () => {
      setSearchText('');
      setIsEditing(false);
      setDisplay(false); // setData([]);
    },
    name: isEditing || value !== undefined ? 'close' : 'ios-search'
  }))), /*#__PURE__*/React.createElement(Item, {
    style: styles.doneButton
  }, /*#__PURE__*/React.createElement(Text, {
    style: styles.cancel,
    onPress: doneSelect
  }, "Done"))), data.length === 0 ? /*#__PURE__*/React.createElement(Spinner, {
    color: "green"
  }) : /*#__PURE__*/React.createElement(FlatList // style={{marginTop: 60}}
  , {
    maxToRenderPerBatch: 10,
    data: searchText === '' ? data : data.filter(item => item.label.toLowerCase().includes(searchText.toLowerCase())),
    disableScrollViewPanResponder: true,
    renderItem: ({
      item,
      index
    }) => /*#__PURE__*/React.createElement(ListItem, {
      key: index,
      style: {
        marginRight: 15,
        marginLeft: 15
      },
      onPress: () => handlerChanged(item)
    }, /*#__PURE__*/React.createElement(Text, {
      style: {
        color: (item === null || item === void 0 ? void 0 : item.isSelected) === true ? '#FD8282' : 'black'
      }
    }, item.label)),
    keyExtractor: item => item.value,
    extraData: data,
    scrollEnabled: true,
    style: {
      marginBottom: 80
    }
  })));
};
//# sourceMappingURL=SelectSearchBar.js.map