import React from 'react';
import { Item, Text, View, Spinner } from 'native-base';
import { StyleSheet, Modal, SafeAreaView } from 'react-native';
import { TreeListItem } from './TreeListItem';
const styles = StyleSheet.create({
  barContainer: {
    padding: 5,
    justifyContent: 'center',
    flexDirection: 'row'
  },
  icon: {},
  doneButton: {
    alignItems: 'center',
    justifyContent: 'center',
    margin: 10,
    flexDirection: 'row',
    borderBottomWidth: 0
  },
  cancel: {
    color: '#5FC9F8'
  }
});
export const DropdownList = props => {
  const {
    data,
    value,
    showModal,
    closeModal,
    onChange,
    childName,
    parentName
  } = props;

  const doneSelect = () => {
    closeModal();
  };

  return /*#__PURE__*/React.createElement(Modal, {
    visible: showModal,
    onDismiss: closeModal
  }, /*#__PURE__*/React.createElement(SafeAreaView, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(View, {
    style: styles.barContainer
  }, /*#__PURE__*/React.createElement(Item, {
    style: styles.doneButton
  }, /*#__PURE__*/React.createElement(Text, {
    style: styles.cancel,
    onPress: doneSelect
  }, "Done"))), data.length === 0 ? /*#__PURE__*/React.createElement(Spinner, {
    color: "green"
  }) : /*#__PURE__*/React.createElement(TreeListItem, {
    data: data,
    childName: childName,
    parentName: parentName,
    value: value,
    onChange: onChange
  })));
};
//# sourceMappingURL=DropdownList.js.map