function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { Button as ButtonX, Icon, Text } from 'native-base';
import { StyleSheet } from 'react-native';
const primaryColor = '#FD8282';
const styles = StyleSheet.create({
  input: {
    borderWidth: 1,
    borderColor: '#999999',
    borderRadius: 6,
    paddingLeft: 10,
    marginBottom: 15
  },
  default: {
    // borderWidth: 1,
    // borderColor: '#999999',
    borderRadius: 6,
    flexDirection: 'row',
    backgroundColor: 'white',
    justifyContent: 'center',
    alignItems: 'center'
  },
  primary: {
    // borderWidth: 1,
    // borderColor: '#999999',
    borderRadius: 6,
    flexDirection: 'row',
    backgroundColor: primaryColor,
    justifyContent: 'center',
    alignItems: 'center'
  },
  transparent: {
    borderWidth: 2,
    borderColor: primaryColor,
    borderRadius: 6,
    flexDirection: 'row',
    // backgroundColor: primaryColor,
    justifyContent: 'center',
    alignItems: 'center'
  },
  textDefault: {
    color: primaryColor,
    justifyContent: 'center',
    fontWeight: 'normal',
    fontSize: 17
  },
  iconDefault: {
    color: primaryColor,
    justifyContent: 'center',
    fontSize: 25
  },
  textPrimary: {
    color: 'white',
    justifyContent: 'center',
    fontSize: 17
  },
  iconPrimary: {
    color: 'white',
    justifyContent: 'center',
    fontSize: 25
  }
});
export const Button = props => {
  const {
    textProps,
    iconProps,
    type,
    iconName,
    children
  } = props;

  const propsX = _objectSpread({}, props);

  delete propsX.textProps;
  delete propsX.iconProps;

  if (iconName) {
    propsX.icon = true;
  }

  const renderButton = (buttonStyle, textStyle, iconStyle) => {
    if (type === 'transparent') {
      propsX.transparent = true;
    }

    return /*#__PURE__*/React.createElement(ButtonX, _extends({}, propsX, {
      bordered: false,
      style: propsX.style ? _objectSpread(_objectSpread({}, propsX.style), buttonStyle) : buttonStyle
    }), /*#__PURE__*/React.createElement(Text, _extends({}, textProps, {
      uppercase: false,
      style: textStyle
    }), iconName && /*#__PURE__*/React.createElement(Icon, _extends({}, iconProps, {
      name: iconName,
      style: iconStyle
    })), "\xA0", children));
  };

  switch (type) {
    case 'primary':
      return renderButton(styles.default, styles.textDefault, styles.iconDefault);

    case 'success':
      return renderButton(_objectSpread(_objectSpread({}, styles.primary), {}, {
        backgroundColor: '#2ED47A'
      }), styles.textPrimary, styles.iconPrimary);

    case 'danger':
      return renderButton(_objectSpread(_objectSpread({}, styles.primary), {}, {
        backgroundColor: '#F50E0E'
      }), styles.textPrimary, styles.iconPrimary);

    case 'warning':
      return renderButton(_objectSpread(_objectSpread({}, styles.primary), {}, {
        backgroundColor: '#FFCF5C'
      }), styles.textPrimary, styles.iconPrimary);

    case 'transparent':
      return renderButton(styles.transparent, styles.textPrimary, styles.iconPrimary);

    case 'custom-full':
      return /*#__PURE__*/React.createElement(ButtonX, propsX, props.children);

    case 'custom':
      return /*#__PURE__*/React.createElement(ButtonX, propsX, propsX.icon && /*#__PURE__*/React.createElement(Icon, iconProps), /*#__PURE__*/React.createElement(Text, _extends({
        uppercase: false
      }, textProps), props.children));

    default:
      return renderButton(styles.primary, styles.textPrimary, styles.iconPrimary);
  }
};
//# sourceMappingURL=Button.js.map