function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useMemo, useState } from 'react';
import { styles } from './styles';
import { Item, Label, Text, View } from 'native-base';
import { TouchableOpacity, Image } from 'react-native';
import { default as ImagePickerX } from 'react-native-image-picker';
export const ImagePicker = props => {
  const {
    type,
    label,
    labelProps,
    style,
    ImagePickerStyle,
    validationInfo,
    onChange,
    value,
    pickerOptions
  } = props;
  const [image, setImage] = useState();
  const options = {
    title: 'Select Picture',
    mediaType: 'photo',
    allowsEditing: true,
    quality: 0.7,
    // storageOptions: {
    //   skipBackup: true,
    //   path: 'images',
    // },
    maxWidth: type === 'avatar' ? 300 : 1000,
    maxHeight: type === 'avatar' ? 300 : 700
  }; // useEffect(() => {
  //  if(type === 'avatar'){
  //    setImageProps({
  //
  //    })
  //  }
  // })

  const onPress = () => {
    ImagePickerX.showImagePicker(pickerOptions ? _objectSpread(_objectSpread({}, options), pickerOptions) : options, response => {
      if (response.didCancel) {
        console.log('User cancelled image picker');
      } else if (response.error) {
        console.log('ImagePicker Error: ', response.error);
      } else if (response.customButton) {
        console.log('User tapped custom button: ', response.customButton);
      } else {
        setImage({
          uri: response.uri
        });
        onChange("data:image/png;base64,".concat(response.data));
      }
    });
  };

  const imageSrc = useMemo(() => {
    if (value && (value === (image === null || image === void 0 ? void 0 : image.uri) || (image === null || image === void 0 ? void 0 : image.uri) === undefined)) {
      return {
        uri: value
      };
    }

    return image;
  }, [value, image]);

  const renderElement = pickerStyleX => {
    return /*#__PURE__*/React.createElement(Item, {
      stackedLabel: label !== undefined,
      style: style !== undefined ? _objectSpread(_objectSpread({}, styles.itemStyle), style) : styles.itemStyle
    }, label && /*#__PURE__*/React.createElement(Label, _extends({}, labelProps, {
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, styles.textDefault), labelProps.style) : styles.textDefault
    }), label, '   ', validationInfo && (validationInfo === null || validationInfo === void 0 ? void 0 : validationInfo.length) > 0 && /*#__PURE__*/React.createElement(Text, {
      style: {
        color: '#f39c12',
        marginLeft: 5
      }
    }, validationInfo)), /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: onPress
    }, !imageSrc ? /*#__PURE__*/React.createElement(View, {
      style: ImagePickerStyle ? _objectSpread(_objectSpread({}, ImagePickerStyle), pickerStyleX) : pickerStyleX
    }, /*#__PURE__*/React.createElement(Image, {
      style: {
        height: 50,
        width: 50
      },
      source: require('./ImageIcon.png')
    })) : /*#__PURE__*/React.createElement(Image, {
      source: imageSrc // resizeMethod={'resize'}
      ,
      resizeMode: type === 'avatar' ? undefined : 'cover',
      style: ImagePickerStyle ? _objectSpread(_objectSpread({}, ImagePickerStyle), pickerStyleX) : pickerStyleX
    })));
  };

  if (type === 'avatar') {
    return renderElement(styles.avatar);
  }

  return renderElement(styles.defaultImage);
};
//# sourceMappingURL=ImagePicker.js.map