function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { Icon, Input as InputX, Item, Label, Text } from 'native-base';
import { styles } from './styles';
export const Input = props => {
  const {
    type,
    label,
    labelProps,
    iconName,
    iconProps,
    style,
    inputStyle,
    validationInfo
  } = props;

  const propsX = _objectSpread({}, props);

  propsX.style = inputStyle;
  delete propsX.labelProps;
  delete propsX.iconProps;
  delete propsX.type;
  delete propsX.label;
  delete propsX.inputStyle;

  const renderElement = (itemStyle, inputStyleX, labelStyle, iconStyle) => {
    return /*#__PURE__*/React.createElement(Item, {
      stackedLabel: label !== undefined,
      style: style !== undefined ? _objectSpread(_objectSpread({}, itemStyle), style) : itemStyle
    }, label && /*#__PURE__*/React.createElement(Label, _extends({}, labelProps, {
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, labelStyle), labelProps.style) : labelStyle
    }), label, '   ', validationInfo && (validationInfo === null || validationInfo === void 0 ? void 0 : validationInfo.length) > 0 && /*#__PURE__*/React.createElement(Text, {
      style: {
        color: '#f39c12',
        marginLeft: 5
      }
    }, validationInfo)), /*#__PURE__*/React.createElement(Item, null, /*#__PURE__*/React.createElement(InputX, _extends({
      placeholderTextColor: '#C4C4C4'
    }, propsX, {
      style: inputStyle ? _objectSpread(_objectSpread({}, inputStyleX), inputStyle) : inputStyleX
    })), iconName && /*#__PURE__*/React.createElement(Icon, _extends({
      active: true
    }, iconProps, {
      name: iconName,
      style: (labelProps === null || labelProps === void 0 ? void 0 : labelProps.style) ? _objectSpread(_objectSpread({}, iconStyle), iconProps === null || iconProps === void 0 ? void 0 : iconProps.style) : iconStyle
    }))));
  };

  switch (type) {
    case 'material':
      return renderElement(styles.itemStyleMaterial, styles.material, styles.textMaterial, styles.iconWhite);

    case 'material-black':
      return renderElement(styles.itemStyleMaterialBlack, styles.materialBlack, _objectSpread(_objectSpread({}, styles.textMaterial), {}, {
        color: 'black'
      }), styles.iconDefault);

    case 'bordered':
      return renderElement(styles.itemStyle, // {},
      _objectSpread({}, styles.bordered), _objectSpread(_objectSpread({}, styles.textDefault), {}, {
        color: '#979797'
      }));

    default:
      return renderElement(styles.itemStyle, styles.default, styles.textDefault);
  }
};
//# sourceMappingURL=Input.js.map