import React from 'react';
import { Label } from 'native-base';
import { StyleSheet, TouchableOpacity } from 'react-native';
const styles = StyleSheet.create({
  one: {
    color: 'white',
    fontSize: 30
  },
  two: {
    color: 'white',
    fontSize: 25
  }
});
export const Title = props => {
  const {
    text,
    style,
    type,
    onPress,
    action
  } = props;

  const getStyle = () => {
    switch (type) {
      case 'one':
        return styles.one;

      case 'two':
        return styles.two;

      default:
        return styles.one;
    }
  };

  if (action && action === 'touchable') {
    return /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: onPress
    }, /*#__PURE__*/React.createElement(Label, {
      style: [getStyle(), style && style]
    }, text));
  }

  return /*#__PURE__*/React.createElement(Label, {
    style: [getStyle(), style && style]
  }, text);
};
//# sourceMappingURL=Title.js.map